#!/sbin/sh

# Set what you want to display when installing your module

ui_print ""
sleep 1
ui_print "************************************"
ui_print "*      <- Celestial Tweaks ->      *"
ui_print "************************************"
sleep 1
ui_print " "
ui_print "Module info: "
ui_print "• Version         : v1.2L rev"
ui_print " "
ui_print "Device info:"
ui_print "• Brand           : $(getprop ro.product.system.brand) "
ui_print "• Device          : $(getprop ro.product.system.model) "
ui_print "• Processor       : $(getprop ro.product.board) "
ui_print "• Android Version : $(getprop ro.system.build.version.release) "
ui_print "• Architecture    : $(getprop ro.product.cpu.abi) "
ui_print "• Kernel Version  : $(uname -r) "
ui_print " "
ui_print "Thanks to the Developer :"
sleep 0.2
ui_print "• Bias_khaliq"
sleep 0.2
ui_print "• Tytydraco"
sleep 0.2
ui_print "• iamlooper"
sleep 0.2
ui_print "• hirauki"
sleep 0.2
ui_print "• NotZeetaa"
sleep 0.2
ui_print "• akemiinawa"
sleep 0.2
ui_print "• lybxlpsv"
sleep 0.2
ui_print ""
ui_print "• All my friends who contributed to the"
ui_print "  development of the project and many others"
ui_print ""
ui_print "Notes:"
ui_print "• Do not use the GMS Doze Module"
ui_print "• Do not use the Lyb big.LITTLE force"
sleep 1
ui_print ""
ui_print "-> Installing Module Please Wait"

# Patch the XML and place the modified one to the original directory
gms_doze_installer() {
ui_print "- Patching XML files"
GMS0="\"com.google.android.gms"\"
STR1="allow-in-power-save package=$GMS0"
STR2="allow-in-data-usage-save package=$GMS0"
NULL="/dev/null"
ui_print "- Finding system XML"
SYS_XML="$(
SXML="$(find /system_ext/* /system/* /product/* \
/vendor/* -type f -iname '*.xml' -print)"
for S in $SXML; do
  if grep -qE "$STR1|$STR2" $ROOT$S 2> $NULL; then
    echo "$S"
  fi
done
)"

PATCH_SX() {
for SX in $SYS_XML; do
  mkdir -p "$(dirname $MODPATH$SX)"
  cp -af $ROOT$SX $MODPATH$SX
  ui_print "  Patching: $SX"
  sed -i "/$STR1/d;/$STR2/d" $MODPATH/$SX
done

# Merge patched files under /system dir
for P in product vendor; do
  if [ -d $MODPATH/$P ]; then
    mkdir -p $MODPATH/system/$P
    mv -f $MODPATH/$P $MODPATH/system/
  fi
done
}

# Search and patch any conflicting modules (if present)
# Search conflicting XML files
MOD_XML="$(
MXML="$(find /data/adb/* -type f -iname "*.xml" -print)"
for M in $MXML; do
  if grep -qE "$STR1|$STR2" $M; then
    echo "$M"
  fi
done
)"

PATCH_MX() {
ui_print "- Finding conflicting XML"
for MX in $MOD_XML; do
  MOD="$(echo "$MX" | awk -F'/' '{print $5}')"
  ui_print "  $MOD: $MX"
  sed -i "/$STR1/d;/$STR2/d" $MX
done
}
}

# Install gms doze
gms_doze_installer

# Set permissions
set_perm_recursive $MODPATH 0 0 0755 0644
set_perm_recursive $MODPATH/system/bin 0 0 0755 0755

# Clean up
find $MODPATH/* -maxdepth 0 \
              ! -name 'module.prop' \
              ! -name 'post-fs-data.sh' \
              ! -name 'service.sh' \
              ! -name 'LICENSE' \
              ! -name 'uninstall.sh' \
              ! -name 'system' \
              ! -name 'system.prop' \
                -exec rm -rf {} \;